﻿using System;
using System.Collections;

namespace ConsoleApplication27
{
    class Program
    {
        static void Main(string[] args)
        {
            NewStack stack = new NewStack(8);

            stack.Push(1, "a");
            Console.WriteLine(stack.Peek(1));
            stack.Push(1, "b");
            stack.Push(1, "c");
            //stack.Push(1, "d");
            Console.WriteLine(stack.Peek(1));
            //stack.Pop(1);
            //Console.WriteLine(stack.Peek(1));


            stack.Push(2, "x");
            Console.WriteLine(stack.Peek(2));
            stack.Push(2, "y");
            stack.Push(2, "z");
            Console.WriteLine(stack.Peek(2));
            stack.Pop(2);
            Console.WriteLine(stack.Peek(2));

            stack.Push(3, "m");
            Console.WriteLine(stack.Peek(3));
            stack.Push(3, "l");
            stack.Push(3, "n");
            //stack.Push(3, "o");
            Console.WriteLine(stack.Peek(3));
            stack.Pop(3);
            stack.Pop(3);
            stack.Pop(3);
            stack.Pop(3);
            Console.WriteLine(stack.Peek(3));


            Console.Read();
        }
    }

    public class NewStack
    {
        object[] arr;
        int top1;
        int top2;

        int top3_left;
        int top3_right;
        bool isLeft;

        public NewStack(int capticy)
        {
            arr = new object[capticy];

            top1 = 0;
            top2 = capticy;

            isLeft = true;
            top3_left = capticy / 2;
            top3_right = top3_left + 1;
        }

        public void Push(int type, object element)
        {
            if (type == 1)
            {
                if (top1 == top3_left + 1)
                    throw new Exception("The stack is full");

                arr[top1] = element;
                top1++;
            }
            else if (type == 2)
            {
                if (top2 == top3_right)
                    throw new Exception("The stack is full");

                top2--;
                arr[top2] = element;
            }
            else //type==3
            {
                if (isLeft)
                {
                    if (top1 == top3_left + 1)
                        throw new Exception("The stack is full");

                    arr[top3_left] = element;
                    top3_left--;
                }
                else
                {
                    if (top2 == top3_right)
                        throw new Exception("The stack is full");

                    arr[top3_right] = element;
                    top3_right++;
                }

                isLeft = !isLeft;
            }
        }

        public object Pop(int type)
        {
            object obj = null;

            if (type == 1)
            {
                if (top1 == 0)
                    throw new Exception("The stack is empty");
                else
                {
                    top1--;
                    obj = arr[top1];
                    arr[top1] = null;
                }
            }
            else if (type == 2)
            {
                if (top2 == arr.Length)
                    throw new Exception("The stack is empty");
                else
                {
                    obj = arr[top2];
                    arr[top2] = null;
                    top2++;
                }
            }
            else //type==3
            {
                if (top3_right == top3_left + 1)
                    throw new Exception("The stack is empty");

                if (isLeft)
                {
                    top3_left++;
                    obj = arr[top3_left];
                    arr[top3_left] = null;
                }
                else
                {
                    top3_right--;
                    obj = arr[top3_right];
                    arr[top3_right] = null;
                }

                isLeft = !isLeft;
            }

            return obj;
        }

        public object Peek(int type)
        {
            if (type == 1)
            {
                if (top1 == 0)
                    throw new Exception("The stack is empty");

                return arr[top1 - 1];
            }

            else if (type == 2)
            {
                if (top2 == arr.Length)
                    throw new Exception("The stack is empty");

                return arr[top2];
            }
            else //type==3
            {
                if (top3_right == top3_left + 1)
                    throw new Exception("The stack is empty");

                if (isLeft)
                    return arr[top3_left + 1];
                else
                    return arr[top3_right - 1];
            }
        }
    }
}